;-*- mode: Scheme; tab-width: 8; fill-column: 70; -*- 
;$Id: alternatives.scm,v 1.5 2005/10/19 13:36:16 inger Exp $ 

(use-translation _ "alterator-alternatives")

(include-as-is "/dialog/functions")

(on-apply (and (next-button enabled) (write-alternatives)))

(on-acc-leave (if (next-button enabled) 'need-confirm))

((global 'disable-next))

(define (on-load-error reason) '())
(define (on-update-error reason)
  (run-dialog `("/error" reason ,reason)))

(define (get-alternatives)
  (woo-read-names "/alternatives/available"
		  (woo-list "/alternatives/available")))

(define *alternatives* (woo-catch
			get-alternatives
			on-load-error))

(define (ask-and-apply)
  (and (next-button enabled)
       (run-dialog '("/alternatives/apply_question"))
       (write-alternatives))
   (next-button enabled #f))

(define *curr-candidate* #f)
(define *curr-alternative* #f)
(define *curr-status* "")
(define *from-auto* #f)

(define (selected-alternative) (alternatives text))
(define (selected-candidate) (candidates text))
(define (selected-mode) (mode text))

(define (get-alternative-info a)
  (woo-first-command
   (woo-read (string-append "/alternatives/view/" a))))

(define (update-candidates-info curr-candidate candidates-str)
  (let ((candidates-list (string-splitting candidates-str #\space)))
    (candidates (items candidates-list))
    (set! *curr-candidate* (string-list-index curr-candidate candidates-list))
    (candidates current *curr-candidate*)))

(define (update-alternative-info alternative)
  (let* ((alternative-info (get-alternative-info alternative))
         (curr-candidate (woo-get-option alternative-info 'points))
         (candidates-str (woo-get-option alternative-info 'candidates))
         (status (string=? (woo-get-option alternative-info 'status) "manual")))
    (set! *curr-candidate* #f)
    (set! *curr-status* status)
    (set! *curr-alternative* alternative)
    
    (update-candidates-info curr-candidate candidates-str)
    (manual checked status)))


(define (write-alternatives)
  (woo-catch
   (lambda ()
     (with-splash-message
      (lambda()
        (splash-message (_ "Please wait ..."))
        (woo-write "/alternatives/"
                   'alternative *curr-alternative*
                   'candidate (selected-candidate) 
                   'status (if (manual checked) "manual" "auto"))
        (next-button enabled #f)
        (set! *from-auto* #f))))
  (lambda (reason) (run-dialog `("/error" reason ,reason)))))

(define (xor x y) (or (and x y) (and (not x) (not y))))

(vbox
 spacing 1
 (groupbox (_ "alternatives")
	   (id 'alternatives
	       (listbox (items *alternatives*)
			(on-select
			 (ask-and-apply)
			 (woo-catch
			  (lambda() (update-alternative-info (selected-alternative)))
			  on-update-error)))))


 (id 'manual (groupbox (_ "use manual settings")
                      checkable #t
                      checked #f
                      (on-toggle
                       (and *curr-candidate*
                            (begin
                              (set! *from-auto* (and (not *curr-status*)
                                                     (manual checked)))
                              (next-button enabled (not (xor (manual checked) *curr-status*))))))

                                  
                      (id 'candidates
                          (listbox (items '())
                                   (on-select
                                        (next-button enabled
                                                     (or *from-auto*
                                                         (not (= *curr-candidate* (candidates current))))))))

                      ))

 )
